// LIO 2010-03-11 v27

#ifndef DEBUG
#define DPRINTF(...)
#else
#define DPRINTF(...) fprintf(stderr, __VA_ARGS__)
#endif

#include <cstdio>
using namespace std;

static int v[100000];

struct node
{
	node *left, *right;
	int n, nleft, v;

	int erase(int i)
	{
		DPRINTF("erase(%u): n=%u, nleft=%u, v=%u\n", i, n, nleft, v);

		if (__builtin_expect(i < nleft, 1))
		{
			--nleft;
			return left->erase(i);
		}
		else if (__builtin_expect(!v, 1))
		{
			return right->erase(i - nleft);
		}
		else
		{
			return v;
		}
	}

	void init(int i)
	{
		if (__builtin_expect(!v, 1))
		{
			left->init(i);
			right->init(i + nleft);
		}
		else
		{
			v = ::v[i];
		}
	}
};

int main()
{
	FILE *f = fopen("aplis.dat", "r");

	int n, k;
	fscanf(f, "%u%u", &n, &k);

	for (int i = 0; i < n; ++i)
	{
		fscanf(f, "%u", &v[i]);
	}

	node tree[200000-1];
	tree->n = n;
	tree->v = 0;

	{
		int i = 0;

		for (node *r = tree, *w = tree; r <= w; ++r)
		{
			r->nleft = r->n / 2;

			if (!r->v)
			{
				DPRINTF("r->n=%u, r->nleft=%u, i=%u\n", r->n, r->nleft, i);

				r->left = ++w;
				w->n = r->nleft;
				w->v = (w->n == 1);

				r->right = ++w;
				w->n = r->n - r->nleft;
				w->v = (w->n == 1);
			}
		}
	}

	tree->init(0);
	DPRINTF("init done\n");

	int ik;
	for (ik = 0; v[ik] != k; ++ik);

	DPRINTF("ik found\n");

	while (n > 1)
	{
		DPRINTF("n=%u, ik=%u\n", n, ik);
		ik = (ik + tree->erase(ik) - 1) % --n;
	}

	freopen("aplis.rez", "w", f);
	fprintf(f, "%u\n", tree->erase(0));
	fclose(f);
	return 0;
}
