// LIO 2010-03-11 v27

#ifndef DEBUG
#define DPRINTF(...)
#else
#define DPRINTF(...) fprintf(stderr, __VA_ARGS__)
#endif

#include <algorithm>
#include <cstdio>
using namespace std;

struct rect
{
	int ren, en;
	bool (operator <)(rect b) const { return ren < b.ren || ren == b.ren && en < b.en; }
	bool (operator ==)(rect b) const { return ren == b.ren && en == b.en; }
};

int main()
{
	FILE *f = fopen("histo.dat", "r");

	int n;
	fscanf(f, "%u", &n);

	int h[100000];

	for (int i = 0; i < n; ++i)
	{
		fscanf(f, "%u", &h[i]);
	}

	int right[100000], stack[100000];
	int *top = stack;
	stack[0] = 0;

	for (int i = 1; i < n; ++i)
	{
		while (top >= stack && h[i] < h[*top])
		{
			right[*top--] = i;
		}

		*++top = i;
	}

	while (top >= stack)
	{
		right[*top--] = n;
	}

	int left[100000];
	top = stack;
	stack[0] = n - 1;

	for (int i = n - 2; i >= 0; --i)
	{
		while (top >= stack && h[i] < h[*top])
		{
			left[*top--] = i;
		}

		*++top = i;
	}

	while (top >= stack)
	{
		left[*top--] = -1;
	}

	rect rects[100000];

	for (int i = 0; i < n; ++i)
	{
		rects[i] = (rect) { left[i], right[i] };
	}

	sort(rects, rects + n);
	rect *end = unique(rects, rects + n);

	freopen("histo.rez", "w", f);
	fprintf(f, "%u\n", end - rects);
	fclose(f);
	return 0;
}
