// LIO 2010-03-11 v27

#ifndef DEBUG
#define DPRINTF(...)
#else
#define DPRINTF(...) fprintf(stderr, __VA_ARGS__)
#endif

#include <stdio.h>

int main()
{
	FILE *f = fopen("saukli.dat", "r");

	int n, g[3];
	char subseq[3][101], seq[100001];
	fscanf(f, "%u %s%u %s%u %s%u %s", &n, seq, &g[0], subseq[0], &g[1], subseq[1], &g[2], subseq[2]);
	freopen("saukli.rez", "w", f);

	struct s { int maxlen, mincuts; _Bool endsincut; } a[100001], b[100001];

	for (int ig = 0; ig < 3; ++ig)
	{
		if (g[ig] > n)
		{
			fprintf(f, "-1\n");
			continue;
		}

		char *sseq = subseq[ig];
		struct s *cur = a, *next = b;
		cur[0].maxlen = cur[0].mincuts = cur[0].endsincut = next[0].maxlen = next[0].mincuts = next[0].endsincut = 0;

		for (int i = 1; i <= n; ++i)
		{
			cur[i].maxlen = 0;
			cur[i].mincuts = cur[i].endsincut = 1;
		}

		for (int i = 0, e = g[ig]; i < e; ++i)
		{
			for (int j = i + 1, je = n - e + i + 1; j <= je; ++j)
			{
				DPRINTF("ig=%u, i=%u, j=%u, %c%c=%c, next[j-1]=(%u,%u,%u), cur[j-1]=(%u,%u,%u)\n", ig, i, j, sseq[i], sseq[i] == seq[j - 1] ? '=' : '!', seq[j - 1], next[j-1].maxlen, next[j-1].mincuts, next[j-1].endsincut, cur[j-1].maxlen, cur[j-1].mincuts, cur[j-1].endsincut);

				if (sseq[i] == seq[j - 1])
				{
					if (next[j - 1].maxlen < cur[j - 1].maxlen + 1)
					{
						next[j].maxlen = cur[j - 1].maxlen + 1;
						next[j].mincuts = cur[j - 1].mincuts;
						next[j].endsincut = 0;
					}
					else if (next[j - 1].maxlen > cur[j - 1].maxlen + 1)
					{
						if (next[j - 1].endsincut)
						{
							next[j] = next[j - 1];
						}
						else
						{
							next[j].maxlen = next[j - 1].maxlen;
							next[j].mincuts = next[j - 1].mincuts + 1;
							next[j].endsincut = 1;
						}
					}
					else
					{
						int z = next[j - 1].mincuts;
						if (!next[j - 1].endsincut) ++z;

						if (z <= cur[j - 1].mincuts)
						{
							next[j].maxlen = next[j - 1].maxlen;
							next[j].mincuts = z;
							next[j].endsincut = 1;
						}
						else
						{
							next[j].maxlen = cur[j - 1].maxlen + 1;
							next[j].mincuts = cur[j - 1].mincuts;
							next[j].endsincut = 0;
						}
					}
				}
				else
				{
					if (next[j - 1].endsincut)
					{
						next[j] = next[j - 1];
					}
					else
					{
						next[j].maxlen = next[j - 1].maxlen;
						next[j].mincuts = next[j - 1].mincuts + 1;
						next[j].endsincut = 1;
					}
				}
			}

			struct s *t = cur;
			cur = next;
			next = t;
			next[i + 1].maxlen = 0;
			next[i + 1].mincuts = next[i + 1].endsincut = 1;
		}

		fprintf(f, "%i\n", (cur[n].maxlen == g[ig]) ? cur[n].mincuts : -1);
		DPRINTF("\n");
	}

	fclose(f);
	return 0;
}
